Config={Width=400, Height=400, Xmin=-100, Xmax=100, Ymin=-100, Ymax=100, Split = 4, Expr="abs(x - y) % 20 < 0.0001"}

function between(x, minValue, maxValue)
    return x >= minValue and x <= maxValue
end

function belongto(x, ranges)
   for _,range in ipairs(ranges) do
        if between(x, range[1], range[2]) then return true end
   end
   return false
end

Favorites={
branchname = "Favorites",
{leafname = "axis", tip = "x==0 or y==0", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "rect", tip = "abs(x+50)<10 and abs(y-20)<20", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "lines(V)", tip = "x%15 == 0", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "lines(H)", tip = "y%15 == 0", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "lines(S)", tip = "(y-x)%20 == 0", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "lines(S)", tip = "(y+x)%20 == 0", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "triangular", tip = "y<x+50 and x*y<0 and y>0", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "triangular", tip = "(x>-20 and x<=0 and y<2*x+40 or x>=0 and x<20 and y<40-2*x) and y>0", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "disk", tip = "x^2 + y^2 < 500", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "circle", tip = "abs((x^2 + y^2)  - 1000) < 5", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "ellipse", tip = "abs(((x/2)^2 + y^2)  - 1000) < 5", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "sun", tip = "(x==0 or abs(atan(y/x)%0.2)<0.005) and between(x^2+y^2, 1600,4900) or x^2+y^2<900", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "face", tip = "(x/2-25)^2+(y-50)^2<200 or (x/2+25)^2+(y-50)^2<200 or ((x>-20 and x<=0 and y<2*x+40 or x>=0 and x<20 and y<40-2*x) and y>0) or abs((x/2)^2+(y+30)^2-400)<10 or abs(y-(x/8)^2+80)<0.5", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "circles", tip = "sqrt(x^2 + y^2) % 10 < 0.1", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "wave", tip = "(x^2 + y^2) % 80 < 5", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "sin", tip = "abs(y-20*sin(x/5)) < 0.1", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "chessboard", tip = "sin(y/5)*cos(x/5) < 0.000001", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "cells", tip = "sin(y/3) + sin(x/3) < 0.000001", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "texture", tip = "sin((y/3)^2 + x/2) < 0.1", config = {Xmin=-100, Xmax=100, Ymin=-100,Ymax=100,Split=4}},
{leafname = "texture", tip = "sin(y^2)+cos(x^2) < 0.000001", config = {Xmin=-8, Xmax=8, Ymin=-8,Ymax=8,Split=5}},
{leafname = "spots", tip = "sin(x)^2+cos(y)^2 < 0.5", config = {Xmin=-8, Xmax=8, Ymin=-8,Ymax=8,Split=5}},
{leafname = "Margarita", tip = "mod(sqrt(x^2+y^2)-3.5*atan(x,y)+sin(x)+cos(y),pi)<pi/2", config = {Xmin=-20, Xmax=20, Ymin=-20,Ymax=20,Split=8}},
{leafname = "pattern", tip = "sin(x*sin(y)+y*sin(x)) < 0.001", config = {Xmin=-12, Xmax=12, Ymin=-12,Ymax=12,Split=8}},
{leafname = "untitled", tip = "abs(e^(sin(x)+cos(y))-sin(e^(x+y)))<0.01", config = {Xmin=-10, Xmax=10, Ymin=-10,Ymax=10,Split=15}},
{leafname = "untitled", tip = "abs( sin(sin(x)+cos(y)) - cos(sin(x*y)+cos(x)) )<0.01", config = {Xmin=-10, Xmax=10, Ymin=-10,Ymax=10,Split=10}},
{leafname = "untitled", tip = "abs( sin(x^2+y^2) - cos(x*y) )<0.01", config = {Xmin=-10, Xmax=10, Ymin=-10,Ymax=10,Split=10}},
{leafname = "mesh", tip = "abs( sin(x^2-y^2) - cos(x*y) )<0.01", config = {Xmin=-10, Xmax=10, Ymin=-10,Ymax=10,Split=10}},
{leafname = "untitled", tip = "abs( sin(x^sin(y)+y^cos(x))-cos(y^x+x^y))<0.005", config = {Xmin=0, Xmax=20, Ymin=0,Ymax=20,Split=10}},
{leafname = "Frontispiece", tip = "abs( x/sin(x)+y/sin(y) - x*y/sin(x*y) )<1", config = {Xmin=-10, Xmax=10, Ymin=-10,Ymax=10,Split=10}},
{leafname = "Threesome", tip = "belongto(sin(sqrt((x+5)^2+y^2))*cos(8*atan(y/(x+5)))*sin(sqrt((x-5)^2+(y-5)^2))*cos(8*atan((y-5)/(x-5)))*sin(sqrt(x^2+(y+5)^2))*cos(8*atan((y+5)/x)), {{-0.1,0},{0.2,math.huge}})", config = {Xmin=-10, Xmax=10, Ymin=-10,Ymax=10,Split=10}},
{leafname = "TaiChi", tip = "x^2+y^2<64 and x^2+(y-4)^2>16 and x^2+(y+4)^2>1 and x<=0 or between(x^2+(y+4)^2,1,16) or x^2+(y-4)^2<1 or abs(sqrt(x^2+y^2)-8)<0.005", config = {Xmin=-10, Xmax=10, Ymin=-10,Ymax=10,Split=10}},
}
